﻿/// <reference path="jquery/jquery-1.5.2.js" />
/// <reference path="jquery-ui/jquery-ui-1.8.11.min.js" />
/// <reference path="jquery.swfobject/jquery.swfobject.1-1-1.min.js" />
/// <reference path="sh/shCore.js" />
/// <reference path="sh/shBrushJScript.js" />
/// <reference path="text_effects/jquery.text_effects.js" />

jQuery.fn.reverse = function () {
    return this.pushStack(this.get().reverse(), arguments);
};

var codeLine = 1;
var codeLineMax = 1;

//var reqStep = 0;
//var reqStepMessage = [ "Ο χρήστης αποστέλλει μέσω του φυλλομετρητή αίτημα για την προβολή μιας συγκεκριμένης σελίδας" ,
//                       "Το αίτημα προωθείται μέσω του Διαδικτύου και του πρωτοκόλλου HTTP προκειμένου να βρεθεί ο εξυπηρέτης που φιλοξενεί την σελίδα",
//                       "Ο εξυπηρέτης λαμβάνει το αίτημα και αναζητά στο τοπικό του σύστημα αρχείων για το αρχείο που περιέχει την σελίδα που ζητήθηκε",
//                       "Ο εξυπηρέτης στέλνει στον φυλλομετρητή του χρήστη την σελίδα που ζητήθηκε, χρησιμοποιώντας ξανά το πρωτόκολλο HTTP" 
//                     ];

var arrCode = new Array();

function showRequest(file, type) {
    $("#imgCloud").stop(true, true);
    $("#imgServer").stop(true, true);
    $("#imgIcon").stop(true, true);
    $("#imgReplay").stop(true, true);

    $("#imgCloud").addClass("Hidden");
    $("#imgCloudStatic").addClass("Hidden");
    $("#imgIcon").addClass("Hidden");
    $("#imgServer").addClass("Hidden");
    $("#imgReplay").addClass("Hidden");
    $("#dlgRequest").dialog("option", "title", "Αίτηση " + file + "...");
    $("#divBrowser").html("GET " + file + ".");

    var $divRequestContent = $("#divRequestContent");
    $("*", $divRequestContent).each(function (i) {
        var strTitle = new String($(this).attr("title"));
        if (type == 1) {
            strTitle = strTitle.replace("εικόνα", "σελίδα");
            strTitle = strTitle.replace("εικόνας", "σελίδας");
            $("#imgIcon").attr("src", "images/html.png");
        }
        if (type == 2) {
            strTitle = strTitle.replace("σελίδα", "εικόνα");
            strTitle = strTitle.replace("σελίδας", "εικόνας");
            $("#imgIcon").attr("src", "images/" + file);
        }
        $(this).attr("title", strTitle);
    });

    $("#divBrowser").typewriter(function () {
        var options = {};
        $("#imgCloud").removeClass("Hidden");
        $("#imgCloud").show("pulsate", options, 1500, function () {
            $("#imgCloud").addClass("Hidden");
            $("#imgCloudStatic").removeClass("Hidden");
            $("#imgServer").removeClass("Hidden");
            $("#imgServer").show("drop", { direction: "left", mode: "show" }, 3000, function () {
                $("#imgIcon").removeClass("Hidden");
                $("#imgIcon").show("slide", { direction: "down", mode: "show" }, 2000, function () {
                    $("#imgReplay").removeClass("Hidden");
                    $("#imgReplay").show("slide", { direction: "right", mode: "show" }, 500, null);
                });
            });
        });
        ;
    });

    $("#dlgRequest").dialog("open");
}


$(document).ready(function () {
    $("#btnNext").button({
        text: false,
        icons: {
            primary: "ui-icon-seek-next"
        }
    })
    .click(function () {
        var $ajaxCode = $("#ajaxCode");
        $(".highlighted", $ajaxCode).removeClass("highlighted");
        if (codeLine < codeLineMax)
            codeLine++;
        $(".number" + codeLine, $ajaxCode).addClass("highlighted");

        var code = new String();
        for (i = 0; i < codeLine - 1; i++)
            code = code.concat(arrCode[i]);

        if (arrCode[codeLine - 2].indexOf("<img") != -1)
            showRequest("client_server.png", 2);

        $("#ajaxPage").html(code);
    });

    $("#btnPrev").button({
        text: false,
        icons: {
            primary: "ui-icon-seek-prev"
        }
    })
    .click(function () {
        var $ajaxCode = $("#ajaxCode");
        $(".highlighted", $ajaxCode).removeClass("highlighted");
        if (codeLine > 1)
            codeLine--;
        $(".number" + codeLine, $ajaxCode).addClass("highlighted");

        var code = new String();
        for (i = 0; i < codeLine; i++)
            code = code.concat(arrCode[i]);

        $("#ajaxPage").html(code);
    });


    $("#imgPlay").hover(
        function () {
            $(this).attr("src", "images/play_over.png");
        },
        function () {
            $(this).attr("src", "images/play.png");
        }
    )
    .click(function () {
        $("#sakis").hide();

        var $ajaxCode = $("#ajaxCode");
        $(".highlighted", $ajaxCode).removeClass("highlighted");
        codeLine = 1;
        $(".number1", $ajaxCode).addClass("highlighted");

        $("#ajaxPage").html("");

        showRequest("example.html", 1);
    });

    $("#imgReplay").hover(
        function () {
            $(this).attr("src", "images/play_over.png");
        },
        function () {
            $(this).attr("src", "images/play.png");
        }
    )
    .click(function () {
        var strTitle = new String($("#dlgRequest").dialog("option", "title"));
        if (strTitle.indexOf("html") != -1)
            showRequest("example.html", 1);
        else
            showRequest("client_server.png", 2);
    });


    SyntaxHighlighter.defaults['highlight'] = codeLine;

    var strPre = $("#ajaxCode").text();
    arrCode = strPre.split("\n");
    codeLineMax = arrCode.length;
    codeLine = 1;


    $("#dlgRequest").dialog({
        autoOpen: false,
        closeOnEscape: false,
        width: 600,
        height: 400,
        modal: true,
        stack: false,
        resizable: false,
        title: "Αποστολή αιτήματος",
        open: function (event, ui) {
        },
        close: function (event, ui) {
            $("#sakis").show();
            $("#ajaxCode").attr("style", "width:430px");
        },
        buttons: {
            "Κλείσιμο": function () {
                $("#dlgRequest").dialog("close");
            }
        }
    });

    $("#sakis").hide();
    SyntaxHighlighter.all();

});